const system = require('../../../system');
const CtlBase = require('../../ctl.base');
class TreearchCtl extends CtlBase {
  constructor() {
    super('common', CtlBase.getServiceName(TreearchCtl));
  }
  async getTreeArchByCode(p, q, req) {
    const { code } = p;
    const { archName } = p;
    const rtn = await this.service.getTreeArchByCode(archName, code);
    return system.getResult(rtn);
  }
  async getRegions(p, q, req) {
    const regionjson = await this.service.getRegions();
    return system.getResult({ regionJson: regionjson });
  }
  async getSysArchJSON(p, q, req) {
    const sysArchJSON = await this.service.getSysArchJSON();
    return system.getResult({ sysArchJSON });
  }
  async saveSysArchJSON(p, q, req) {
    const sysArchJSON = await this.service.saveSysArchJSON(p.sysArchJSON, p);
    return system.getResult({ sysArchJSON });
  }
  async saveRegions(p, q, req) {
    const regionjson = await this.service.saveRegions(p.regionJson);
    return system.getResult({ regionJson: regionjson });
  }
  async getProductcats(p, q, req) {
    const productcatJson = await this.service.getProductcats();
    return system.getResult({ productcatJson });
  }
  async saveProductcats(p, q, req) {
    const productcatJson = await this.service.saveProductcats(p.productcatJson);
    return system.getResult({ productcatJson });
  }
}
module.exports = TreearchCtl;
