const system = require('../../../system');
const http = require('http');
const querystring = require('querystring');
const settings = require('../../../../config/settings');
const CtlBase = require('../../ctl.base');


const cacheBaseComp = null;
class PricecatCtl extends CtlBase {
  constructor() {
    super('product', CtlBase.getServiceName(PricecatCtl));
    this.pricestrategyService = system.getObject('service.product.pricestrategySve');
  }
  async buildPriceStrategy(p, q, req) {
    const { pricetypes } = p;
    const rtn = await this.pricestrategyService.buildPriceStrategy(pricetypes);
    if (rtn) {
      if (rtn.status == -1) {
        return system.getResult(null, rtn.msg);
      }
      return system.getResult({});
    }
    return system.getResult({});
  }
}
module.exports = PricecatCtl;
