const CacheBase = require('../cache.base');
const system = require('../../system');
const settings = require('../../../config/settings');

class LoginTimesCache extends CacheBase {
  constructor() {
    super();
  }

  isdebug() {
    return false;
  }

  desc() {
    return '缓存登录错误次数信息';
  }

  prefix() {
    return 'g_login_times_:';
  }

  async buildCacheVal(cachekey, inputkey, val, ex, ...items) {
    if (val) {
      return val;
    }
    return null;
  }

  async incrAsync(key) {
    const cachekey = this.prefix + key;
    const cache = await this.getCache(key);
    if (!cache) {
      await this.cache(key, '0', 60);
    }
    return this.redisClient.incr(cachekey);
  }
}

module.exports = LoginTimesCache;
