const system = require('../../../system');
const ServiceBase = require('../../sve.base');
class RoleService extends ServiceBase {
  constructor() {
    super('auth', ServiceBase.getDaoName(RoleService));
    // this.appDao=system.getObject("db.appDao");
  }
  async findOneByCode(code) {
    return this.dao.model.findOne({ where: { code } });
  }

  async update(qobj) {
    const data = await this.dao.model.findOne({
      where: {
        company_id: Number(qobj.company_id),
        id: qobj.id,
      },
    });
    if (!data) {
      throw new Error('无权限');
    }
    const result = await this.dao.update(qobj);
    return result;
  }

  async delete(qobj) {
    const data = await this.dao.model.findOne({
      where: {
        company_id: Number(qobj.company_id),
        id: qobj.id,
      },
    });
    if (!data) {
      throw new Error('无权限');
    }
    const result = await this.dao.delete(qobj);
    return result;
  }
}
module.exports = RoleService;
