const system = require('../../../system');
const ServiceBase = require('../../sve.base');
const settings = require('../../../../config/settings');
const appconfig = system.getSysConfig();
const fs = require('fs');
class PricestrategyService extends ServiceBase {
  constructor() {
    super('product', ServiceBase.getDaoName(PricestrategyService));
  }
  async buildPriceStrategy(pricetypes) {
    const dks = [];
    const codeattr = [];
    const pricetypenames = [];
    pricetypes.forEach((item) => {
      dks.push(item.options.split(','));
      codeattr.push(item.code);
      pricetypenames.push(item.name);
    });
    const codeunion = codeattr.join('~');
    // 先按照codeunion检查是否已经生成
    const se = await this.dao.findOne({ codeunion });
    if (se != null) {
      return { status: -1, msg: '定价策略已经存在，无需再次生成' };
    }
    const nameunion = pricetypenames.join('~');
    const dkresults = this.makedks(dks);
    const strategys = [];
    for (const dk of dkresults) {
      const tmp = {
        codeunion,
        nameunion,
        optionunion: dk.split('|').join(','),
      };
      strategys.push(tmp);
    }
    const self = this;
    return this.db.transaction(async (t) => {
      const r = await self.dao.bulkCreate(strategys, t);
      return { status: 0 };
    });
  }
  makedks(rows) {
    let mid = [];
    if (rows.length == 1) {
      mid = rows[0];
      return mid;
    }
    for (let i = 0; i < rows.length; i++) {
      if (mid.length == 0) {
        console.log('in..........');
        const one = rows[i];
        const two = rows[++i];
        console.log(two, '..........');
        // eslint-disable-next-line no-loop-func
        one.forEach((item) => {
          two.forEach((c) => {
            mid.push(`${item}|${c}`);
          });
        });
      } else {
        const next = rows[i];
        const tmparray = [];
        mid.forEach((m) => {
          next.forEach((n) => {
            tmparray.push(`${m}|${n}`);
          });
        });
        mid = tmparray;
      }
    }
    return mid;
  }
}
module.exports = PricestrategyService;
