// var log4js = require('log4js');
const settings = require('../../config/settings');
const uuidv4 = require('uuid/v4');
const system = require('../system');
class LogClient {
  constructor() {
    // log4js.configure(settings.basepath+"/app/config/log4js.json");
    // this.logerApp=log4js.getLogger("app");
    // this.logerHttp=log4js.getLogger("http");
  }
  getUUID() {
    const uuid = uuidv4();
    const u = uuid.replace(/-/g, '');
    return u;
  }
  async log(pobj, req, rtninfo, errinfo) {
    rtninfo.requestId = this.getUUID();
    req.params.param = pobj;
    if (!['findSystemMsgCount', 'findUnreadCount'].includes(((req.params && req.params.method) || ''))) {
      // 第三个字段应该存公司id
      system.execLogs(`${settings.appname}_${req.xctx.codetitle}`, req.params, `_${pobj.company_id}_`, rtninfo, errinfo).then((res) => {
        if (res && res.status == 1) {
          console.log('log.....success');
        } else {
          console.log('log.....fail');
        }
      })
        .catch((e) => {
          console.log('log.....fail');
        });
    }
  }

  async logList(pobj) {
    const { search, pageInfo, company_id: companyId } = pobj;
    const { userName, errorInfo, messageBody, resultInfo, created_at: createdAt, opTitle, requestId } = search;
    const query = {
      indexName: `logs-sytxpublic-msgq-${settings.logindex}`,
      pageSize: pageInfo.pageSize,
      currentPage: pageInfo.pageNo,
    };
    if (companyId && companyId != 1) {
      query.identifyCode = `_${companyId}_`;
    }
    if (opTitle) {
      query.opTitle = opTitle;
    }
    if (requestId) {
      query.requestId = requestId;
    }
    if (userName) {
      query.messageBody = userName;
    }
    if (errorInfo) {
      query.errorInfo = errorInfo;
    }
    if (messageBody) {
      query.messageBody = messageBody;
    }
    if (resultInfo) {
      query.resultInfo = resultInfo;
    }
    if (createdAt && createdAt[0] && createdAt[1]) {
      query.startTime = new Date(createdAt[0]).getTime();
      query.entTime = new Date(createdAt[1]).getTime();
    }
    console.log('请求--------日志');
    console.log(settings.logUrl());
    console.log(query);
    let rtn = await system.postJsonTypeReq(settings.logUrl(), {
      actionType: 'queryLogsData', // Y 功能名称
      actionBody: query,
    });

    if (rtn.statusCode === 200) {
      rtn = rtn.data;
      if (rtn && rtn.status === 1) {
        return rtn.data;
      }
      throw new Error((rtn && rtn.message) || '请联系管理员');
    } else {
      throw new Error(rtn);
    }
  }
}
module.exports = LogClient;
