﻿const url = require('url');
const System = require('../../base/system');
const chnelapi = System.getObject('api.common.channels');
const channelCache = {};

module.exports = function (app) {
  app.get('/autologin', (req, res, next) => {
    // 读取cookie,获取cookie值，
  });

  app.all('*', async (req, res, next) => {
    try {
      let channel = null;
      const hostaddr = req.headers['x-forwarded-host'];
      if (!channelCache[hostaddr]) {
        channel = await chnelapi.getChannels(req.headers['x-forwarded-host']);
        channelCache[hostaddr] = channel;
      } else {
        channel = channelCache[hostaddr];
      }
      if (!channel) {
        next();
      } else {
        const rtn = await chnelapi.channelHandle(channel, `${req.path}/${(req.body && req.body.actionType) || ''}`, req.body);
        if (rtn != null) {
          res.json(rtn);
        } else {
          res.json({ status: -1, message: 'fail' });
        }
      }
    } catch (e) {
      console.log(e);
      res.end(JSON.stringify({ status: -1, message: e }));
    }
  });
  app.post('/login/getpiccode', async (req, res, next) => {
    const captchaSve = System.getObject('service.auth.captchaSve');
    const data = await captchaSve.apiGenerate({});
    res.end(JSON.stringify(data));
  });
  app.get('/api/:gname/:qname/:method', (req, res) => {
    // var classPath = req.params["qname"];
    const methodName = req.params.method;
    const { gname } = req.params;
    classPath = `${gname}.${classPath}`;
    const tClientIp = System.getClientIp(req);
    req.clientIp = tClientIp;
    req.uagent = req.headers['user-agent'];
    // req.classname=classPath;

    const params = [];
    params.push(gname);
    params.push(methodName);
    params.push(req.body);
    params.push(req.query);
    params.push(req);
    let p = null;
    const invokeObj = System.getObject(`api.${classPath}`);
    if (invokeObj.doexec) {
      p = invokeObj.doexec.apply(invokeObj, params);
    }
    p.then((r) => {
      res.end(JSON.stringify(r));
    });
  });
  app.post('/api/:gname/:qname/:method', (req, res) => {
    let classPath = req.params.qname;
    const methodName = req.params.method;
    const { gname } = req.params;
    const params = [];
    classPath = `${gname}.${classPath}`;
    console.log('====================');
    console.log(classPath);
    const tClientIp = System.getClientIp(req);
    req.clientIp = tClientIp;
    req.uagent = req.headers['user-agent'];
    // req.classname=classPath;

    params.push(gname);
    params.push(methodName);
    params.push(req.body);
    params.push(req.query);
    params.push(req);
    let p = null;
    const invokeObj = System.getObject(`api.${classPath}`);
    if (invokeObj.doexec) {
      p = invokeObj.doexec.apply(invokeObj, params);
      p.then((r) => {
        // res.end(JSON.stringify(r));
        res.json(r);
      });
    }
  });
};
