const path = require('path');
const ENVINPUT = {
  KONG_ADMIAN: process.env.KONG_ADMIAN,
  DB_HOST: process.env.DB_HOST,
  DB_PORT: process.env.DB_PORT,
  DB_USER: process.env.DB_USER,
  DB_PWD: process.env.DB_PWD,
  DB_NAME: process.env.PAAS_DB_NAME,
  REDIS_HOST: process.env.REDIS_HOST,
  REDIS_PORT: process.env.REDIS_PORT,
  REDIS_PWD: process.env.REDIS_PWD,
  REDIS_DB: process.env.PAAS_REDIS_DB,
  APP_ENV: process.env.APP_ENV ? process.env.APP_ENV : 'localhost',
  ENCRYPT_KEY: process.env.ENCRYPT_KEY ? process.env.ENCRYPT_KEY : '202007211106',
  ENCRYPT_SECRET: process.env.ENCRYPT_SECRET ? process.env.ENCRYPT_SECRET : 'scbb846246874887b5c7e01cd0816c66',
};
const settings = {
  env: ENVINPUT.APP_ENV,
  encrypt_key: ENVINPUT.ENCRYPT_KEY,
  encrypt_secret: ENVINPUT.ENCRYPT_SECRET,
  salt: '%iatpD1gcxz7iF#B',
  defaultpwd: 'Temp123456',
  changepwdcycle: 365, // 密码更换周期 7天前登录提示更改密码 到期后直接禁用账户
  basepath: path.normalize(path.join(__dirname, '../..')),
  port: process.env.NODE_PORT || 80,
  logindex: 'center_manage',
  appname: 'center_manage',
  kongurl() {
    if (this.env == 'localhost') {
      const localsettings = require('./localsettings');
      return localsettings.kongurl;
    } if (this.env == 'test') {
      return 'http://kong-dbproxy.kong-test:8001/';
    } if (this.env == 'pre') {
      return 'http://kong-dbproxy.kong-pre:8001/';
    }
    return 'http://kong-dbproxy.kong:8001/';
  },
  icUrl() {
    if (this.env == 'localhost') {
      return 'http://ic.com:8000';
    }
    return 'http://icdeliver-service';
  },
  bookUrl() {
    if (this.env == 'localhost') {
      return 'http://192.168.1.6:8889';
    }
    return 'http://bookdeliver-service';
  },
  logUrl() {
    if (this.env == 'localhost') {
      return 'http://192.168.1.128:4019/api/queueAction/producer/springBoard';
    }
    return 'http://logs-sytxpublic-msgq-service/api/queueAction/producer/springBoard';
  },
  pushUrl() {
    if (this.env == 'localhost') {
      // return "http://192.168.18.101:4018/api/queueAction/plsroducer/springBoard";
      return 'http://192.168.1.4:4018/api/queueAction/plsroducer/springBoard';
    }
    return 'http://logs-sytxpublic-msgq-service/api/queueAction/producer/springBoard';
  },
  bpushUrl() { // 代帐系统用于队列
    if (this.env == 'localhost') {
      return 'http://192.168.1.4:4018/api/queueAction/plsroducer/springBoard';
    }
    return 'http://sytxpublic-msgq-service/api/queueAction/producer/springBoard';
  },

  pmappname: 'center-app',
  pmappid: 1,
  pmcompanyid: 1,
  pmroleid: { ta: 1, pr: 2 },
  redis() {
    if (this.env == 'localhost') {
      const localsettings = require('./localsettings');
      return localsettings.redis;
    }
    return {
      host: ENVINPUT.REDIS_HOST,
      port: ENVINPUT.REDIS_PORT,
      password: ENVINPUT.REDIS_PWD,
      db: ENVINPUT.REDIS_DB,
    };
  },
  database() {
    if (this.env == 'localhost') {
      const localsettings = require('./localsettings');
      return localsettings.database;
    }
    return {
      dbname: ENVINPUT.DB_NAME,
      user: ENVINPUT.DB_USER,
      password: ENVINPUT.DB_PWD,
      config: {
        host: ENVINPUT.DB_HOST,
        port: ENVINPUT.DB_PORT,
        dialect: 'mysql',
        operatorsAliases: false,
        pool: {
          max: 5,
          min: 0,
          acquire: 90000000,
          idle: 1000000,
        },
        debug: false,
        timezone: '+08:00',
        dialectOptions: {
          requestTimeout: 999999,
          // instanceName:'DEV'
        },  // 设置MSSQL超时时间
      },
    };
  },
};
settings.ENVINPUT = ENVINPUT;
module.exports = settings;
